import 'dart:ffi' as ffi;

import 'bindings.dart' as ffi;
import 'dylib.dart';
import 'variant.dart';
import 'variant_type.dart';

class GVariantBuilder {
  final ffi.Pointer<ffi.GVariantBuilder> _ptr;

  GVariantBuilder.fromType(GVariantType type)
      : _ptr = dylib.g_variant_builder_new(type.toPointer());

  GVariantBuilder.fromPointer(this._ptr);
  ffi.Pointer<ffi.GVariantBuilder> toPointer() => _ptr;

  void addValue(GVariant value) {
    dylib.g_variant_builder_add_value(_ptr, value.toPointer());
  }

  GVariant end() {
    return GVariant.fromPointer(dylib.g_variant_builder_end(_ptr));
  }

  void dispose() => dylib.g_variant_builder_unref(_ptr);
}
